Annotation of openbsd/fw_update/fw_install.sh, Revision 1.42
1.1 afresh1 1: #!/bin/ksh
1.36 afresh1 2: # $OpenBSD$
1.1 afresh1 3: set -e
4:
1.38 afresh1 5: # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
6: #
7: # Permission to use, copy, modify, and distribute this software for any
8: # purpose with or without fee is hereby granted, provided that the above
9: # copyright notice and this permission notice appear in all copies.
10: #
11: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
12: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
13: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
14: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
15: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
16: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
17: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
18:
1.24 afresh1 19: # Fake up some things from install.sub that we don't need to actually do
1.22 afresh1 20: prefetcharea_fs_list() {
1.27 afresh1 21: echo "${DESTDIR}/tmp"
1.22 afresh1 22: }
23:
1.8 afresh1 24: # tmpdir, do_as, unpriv, and unpriv2 are from install.sub
25:
26: # Create a temporary directory based on the supplied directory name prefix.
27: tmpdir() {
28: local _i=1 _dir
29:
30: until _dir="${1?}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
31: ((++_i < 10000)) || return 1
32: done
33: echo "$_dir"
34: }
1.6 afresh1 35:
36: # Run a command ($2+) as unprivileged user ($1).
37: # Take extra care that after "cmd" no "user" processes exist.
38: #
39: # Optionally:
40: # - create "file" and chown it to "user"
41: # - after "cmd", chown "file" back to root
42: #
43: # Usage: do_as user [-f file] cmd
44: do_as() {
45: (( $# >= 2 )) || return
46:
47: local _file _rc _user=$1
48: shift
49:
50: if [[ $1 == -f ]]; then
51: _file=$2
52: shift 2
53: fi
54:
55: if [[ -n $_file ]]; then
56: >$_file
57: chown "$_user" "$_file"
58: fi
59:
1.42 ! afresh1 60: if [[ -x /usr/bin/su ]]; then
! 61: /usr/bin/su -s /bin/ksh "$_user" -c "$*"
! 62: else
! 63: doas -u "$_user" "$@"
! 64: fi
1.6 afresh1 65: _rc=$?
66:
67: while doas -u "$_user" kill -9 -1 2>/dev/null; do
68: echo "Processes still running for user $_user after: $@"
69: sleep 1
70: done
71:
72: [[ -n $_file ]] && chown root "$_file"
73:
74: return $_rc
75: }
76:
77: unpriv() {
78: do_as _sndio "$@"
79: }
80:
81: unpriv2() {
82: do_as _file "$@"
83: }
84:
1.33 afresh1 85: VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
1.34 afresh1 86: VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
1.33 afresh1 87: FWDIR=${FWDIR:-$VNAME}
1.1 afresh1 88:
1.14 afresh1 89: # TODO: We need the firmware for the system we just installed
90: # not the one we booted from. For example:
91: # * booting from a snapshot bsd.rd that thinks it is the 7.0 release
92: # will install the firmware from the 7.0 directory instead of
93: # from the snapshots dir.
94: # If they're using sysupgrade, then the installer kernel will be correct.
95: # If we're doing this in the installer we can check what they picked
96: # for downloading sets and use that value.
97: # Otherwise, the fw_update after first boot will fix it up for us.
98:
1.7 afresh1 99: HTTP_FWDIR=$FWDIR
1.30 afresh1 100: set -- sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" /var/run/dmesg.boot
1.7 afresh1 101: [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots
102:
103: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
104: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.37 afresh1 105: FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
1.1 afresh1 106:
1.20 afresh1 107: # TODO: support srclocal installation of firmware somehow
1.35 afresh1 108: fw_install() {
1.24 afresh1 109: local _src=$1 _tmpfs_list _tmpfs _tmpsrc \
1.27 afresh1 110: _t=Get _cfile="/tmp/SHA256" _pkgdir=${DESTDIR}/var/db/pkg \
1.25 afresh1 111: _f _r _remove _i _installed
112: local _srclocal=false _unpriv=unpriv
1.26 afresh1 113:
1.15 afresh1 114: local _d _drivers=$(
1.11 afresh1 115: last=''
1.15 afresh1 116: while read _d _m; do
1.11 afresh1 117: grep=grep
1.15 afresh1 118: [ "$last" = "$_d" ] && continue
119: [ "$_m" ] || _m="^$_d[0-9][0-9]* at "
120: [ "$_m" = "${_m#^}" ] && grep=fgrep
121: $grep -q "$_m" /var/run/dmesg.boot || continue
122: echo $_d
123: last=$_d
1.37 afresh1 124: done < $FWPATTERNS
1.11 afresh1 125: )
126:
127: if [ -z "$_drivers" ]; then
1.22 afresh1 128: echo "No devices found which need firmware files to be downloaded."
1.11 afresh1 129: return
130: fi
1.1 afresh1 131:
1.22 afresh1 132: ! _tmpfs_list=$(prefetcharea_fs_list) &&
133: echo "Cannot determine prefetch area" >&2 && return
134:
135: for _tmpfs in $_tmpfs_list; do
136: # Try to clean up from previous runs, assuming
137: # the _tmpfs selection yields the same mount
138: # point.
139: for _tmpsrc in $_tmpfs/firmware.+([0-9]).+([0-9]); do
140: [[ -d $_tmpsrc ]] && rm -r $_tmpsrc
141: done
142:
143: # Create a download directory for the firmware and
144: # check that the _sndio user can read files from
145: # it. Otherwise cleanup and skip the filesystem.
146: if _tmpsrc=$(tmpdir "$_tmpfs/firmware"); then
147: (
148: >$_tmpsrc/t &&
149: $_unpriv cat $_tmpsrc/t
150: ) >/dev/null 2>&1 && break ||
151: rm -r $_tmpsrc
152: fi
153: done
1.1 afresh1 154:
1.11 afresh1 155: [[ ! -d $_tmpsrc ]] &&
1.22 afresh1 156: echo "Cannot create prefetch area" >&2 && return 1
1.1 afresh1 157:
1.16 afresh1 158: # Cleanup from previous runs.
159: rm -f $_cfile $_cfile.sig
160:
1.21 afresh1 161: _t=Get/Verify
1.17 afresh1 162:
1.11 afresh1 163: ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&
1.22 afresh1 164: echo "Cannot fetch SHA256.sig" >&2 && return 1
1.1 afresh1 165:
1.11 afresh1 166: # Verify signature file with public keys.
1.24 afresh1 167: ! $_unpriv -f "$_cfile" \
1.11 afresh1 168: signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&
1.22 afresh1 169: echo "Signature check of SHA256.sig failed" >&2 && return 1
1.11 afresh1 170:
1.15 afresh1 171: for _d in $_drivers; do
1.41 afresh1 172: _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" | sed '$!d' )
1.19 afresh1 173: _installed=$(
1.22 afresh1 174: for fw in "${_pkgdir}/$_d-firmware"*; do
1.19 afresh1 175: [ -e "$fw" ] || continue
176: echo ${fw##*/}
177: done
1.21 afresh1 178: )
1.15 afresh1 179:
180: for _i in $_installed; do
181: if [ "$_f" = "$_i.tgz" ]; then
1.24 afresh1 182: echo "$_i already installed"
1.11 afresh1 183: continue 2
1.1 afresh1 184: fi
185: done
186:
1.11 afresh1 187: rm -f /tmp/h /tmp/fail
188:
189: # Fetch firmware file and create a checksum by piping through
190: # sha256. Create a flag file in case ftp failed. Firmware
191: # from net is written to the prefetch area.
192: ( $_unpriv ftp -D "$_t" -Vmo - "$_src/$_f" || >/tmp/fail ) |
193: ( $_srclocal && unpriv2 sha256 -b >/tmp/h ||
194: unpriv2 -f /tmp/h sha256 -bph /tmp/h >"$_tmpsrc/$_f" )
195:
196: # Handle failed transfer.
197: if [[ -f /tmp/fail ]]; then
198: rm -f "$_tmpsrc/$_f"
1.22 afresh1 199: echo "Fetching of $_f failed!" >&2
200: continue
1.11 afresh1 201: fi
202:
203: # Verify firmware by comparing its checksum with SHA256.
1.22 afresh1 204: if ! fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then
1.11 afresh1 205: [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"
1.22 afresh1 206: echo "Checksum test for $_f failed." >&2
207: continue
1.11 afresh1 208: fi
209:
210: # TODO: Check hash for files before deleting
1.22 afresh1 211: if [ "$_installed" ] && [ -e "${_pkgdir}/$_installed/+CONTENTS" ]; then
1.18 afresh1 212: echo "Uninstalling $_installed"
1.22 afresh1 213: cwd=${_pkgdir}/$_installed
1.11 afresh1 214:
215: set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"
216:
217: while read c g; do
218: case $c in
1.27 afresh1 219: @cwd) cwd="${DESTDIR}/$g"
1.11 afresh1 220: ;;
221: @*) continue
222: ;;
223: *) set -A _remove -- "$cwd/$c" "${_remove[@]}"
224: ;;
225: esac
1.22 afresh1 226: done < "${_pkgdir}/$_installed/+CONTENTS"
1.11 afresh1 227:
1.21 afresh1 228: # We specifically rm -f here because not removing files/dirs
229: # is probably not worth failing over.
1.11 afresh1 230: for _r in "${_remove[@]}" ; do
231: if [ -d "$_r" ]; then
232: # Try hard not to actually remove recursively
233: # without rmdir on the install media.
234: [ "$_r/*" = $( echo "$_r"/* ) ] && rm -rf "$_r"
235: else
236: rm -f "$_r"
237: fi
238: done
239: fi
240:
1.21 afresh1 241: # TODO: Should we mark these so real fw_update can -Drepair?
1.25 afresh1 242: ftp -D "Install" -Vmo- "file:$_tmpsrc/$_f" |
243: tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \
1.28 afresh1 244: -s ",^firmware,${DESTDIR}/etc/firmware," \
1.25 afresh1 245: -C / -zxphf - "+*" "firmware/*"
1.23 afresh1 246:
1.22 afresh1 247: ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL
1.1 afresh1 248: /^@comment pkgpath/ -1a
249: @option manual-installation
250: @option firmware
251: @comment install-script
252: .
253: w
254: EOL
1.11 afresh1 255: done
256: }
1.1 afresh1 257:
1.35 afresh1 258: fw_install "$FWURL"
FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>